//*****************************************
// AT mega328 Pulse Output Program
// CPU Clock:20MHz
//   iq[Yf[^@WȂBOIV[^(8MHz--)ɂj
//
// File Name:port_bit.c
//
//  C:\WinAVR-20100110\doc\avr-libc\avr-libc-user-manual.pdf ɊeCN[ht@C̐
//
//  2016/02/26 Taishi
//  2016/08/05 Modify Switch --> Prev,Down,Up,Next,ON
//*****************************************
#include	<avr/io.h>


#include	"timer.h"
#include	"port_bit.h"

unsigned char	sw[4];							// SW[1] Ɍ݂̏ԁAĂ镨'1'̏ԁA SW[2] ɉꂽuԂ'1'̏ԁA SW[3] ɗꂽuԂ'1'̏
unsigned char	old_sw;

//***************************
//@XCb`Ԃ
// SW[1] Ɍ݂̏ԁAĂ镨'1'̏
// SW[2] ɉꂽuԂ'1'̏
// SW[3] ɗꂽuԂ'1'̏
//  Timer2 ̊荞݂gpĂԂKv
//***************************
void	get_sw(void)
{
	unsigned char	uc;

	if(tim_10ms_sw == 0){
		tim_10ms_sw = 3;									// ROrԊu
		uc = ((~PIND) & (SW_PREV | SW_DOWN | SW_UP | SW_NEXT | SW_ON));	// ]ăXCb`f[^擾
		if (old_sw == uc){									// OƓf[^̎
			sw[0] = sw[1];
			sw[1] = uc;
			sw[2] = ((sw[0] ^ sw[1]) & sw[1]);				// ꂽXCb`f[^
			sw[3] = ((sw[0] ^ sw[1]) & ~sw[1]);				// ꂽXCb`f[^
		}else{
			sw[2] = 0;
			sw[3] = 0;
		}
		old_sw = uc;										// Of[^ɓ
	}else{
		sw[2] = 0;
		sw[3] = 0;
	}
}

//***************************
//@XCb`֌W̏ݒ
//***************************
void	sw_init(void)
{
	DDRD &= ~( (1 << DDD0) | (1 << DDD1) | (1 << DDD2) | (1 << DDD3) | (1 << DDD4) );	// Port-D Bit0,1,2,3,4 : Intput
	PORTD |= ( (1 << PD0) | (1 << PD1) | (1 << PD2) | (1 << PD3) | (1 << PD4) );		// Port-D Bit0,1,2,3,4 : Pullup
}

