//*****************************************
// AT mega328 Pulse Output Program
// CPU Clock:20MHz
//   iq[Yf[^@WȂBOIV[^(8MHz--)ɂj
//
// File Name:port_bit.h
//  wb_[t@C
//
//  C:\WinAVR-20100110\doc\avr-libc\avr-libc-user-manual.pdf ɊeCN[ht@C̐
//
//  2016/02/26 Taishi
//  2016/08/05 Modify Switch --> Prev,Down,Up,Next,ON
//*****************************************

// XCb`

#define	SW_PREV		(1 << PIND0)
#define	SW_DOWN		(1 << PIND1)
#define	SW_UP		(1 << PIND2)
#define	SW_NEXT		(1 << PIND3)
#define	SW_ON		(1 << PIND4)

extern	unsigned char			sw[4];

// kdc
//  PD0: RED LED(H=ON, L=OFF)
#define	led_init()	DDRB |= (1 << DDB0)					// Port-B Bit0 : Output
#define	led_on()	PORTB |=  (1 << PB0)				// LED ON
#define	led_off()	PORTB &= ~(1 << PB0)				// LED OFF


extern	void	get_sw(void);
extern	void	sw_init(void);
